#include <Application.h>
#include <Window.h>
#include <Button.h>
#include <TextControl.h>

const char buttonName[]="PFZ Button";

typedef enum {
 pfz_EQUAL=0,
 pfz_PLUS,
 pfz_MULT,
 pfz_DIV,
 pfz_MINUS
} pfz_OP;

class pfzApplication:public BApplication{
 public:
  pfzApplication();
};

class pfzWindow:public BWindow{
 public:
  pfzWindow();
  bool QuitRequested();
};

class pfzValueButton:public BButton {
 public:
  long FValue;
  pfzValueButton(BRect rect,char *caption,long value);
  status_t Invoke(BMessage *msg);
};

class pfzOpButton:public BButton {
 public:
  pfz_OP FOp;
  pfzOpButton(BRect rect,char *caption,pfz_OP value);
  status_t Invoke(BMessage *msg);
};

class pfzCEButton:public BButton {
 public:
  pfzCEButton(BRect rect,char *caption);
  status_t Invoke(BMessage *msg);
};

pfz_OP OldOP=pfz_EQUAL;
BTextControl *txtControl;
long OldValue=0,NewValue;
bool FErase=false;
char str[15];
bool LastEq=true;

main(){
 pfzApplication app;
 app.Run();
 return(0);
}

pfzApplication::pfzApplication():BApplication("application/x-PFZCalc"){
 new pfzWindow;
}

pfzWindow::pfzWindow():BWindow(
 BRect(100,100,300,350),
 "PFZ Calculator",
 B_TITLED_WINDOW,
 B_NOT_RESIZABLE|B_NOT_ZOOMABLE
){
pfzOpButton *Btn;
 AddChild(new pfzValueButton(BRect(0,150,49,199),"1",1));
 AddChild(new pfzValueButton(BRect(50,150,99,199),"2",2));
 AddChild(new pfzValueButton(BRect(100,150,149,199),"3",3));
 AddChild(new pfzValueButton(BRect(0,100,49,149),"4",4));
 AddChild(new pfzValueButton(BRect(50,100,99,149),"5",5));
 AddChild(new pfzValueButton(BRect(100,100,149,149),"6",6));
 AddChild(new pfzValueButton(BRect(0,50,49,99),"7",7));
 AddChild(new pfzValueButton(BRect(50,50,99,99),"8",8));
 AddChild(new pfzValueButton(BRect(100,50,149,99),"9",9));
 AddChild(new pfzCEButton(BRect(150,50,199,99),"CE"));
 AddChild(new pfzOpButton(BRect(150,100,199,149),"+",pfz_PLUS));
 AddChild(new pfzOpButton(BRect(150,150,199,199),"-",pfz_MINUS));
 AddChild(Btn=new pfzOpButton(BRect(154,204,195,245),"=",pfz_EQUAL));
 Btn->MakeDefault(true);
 Btn->SetFlags(Btn->Flags() & ~B_NAVIGABLE);
 AddChild(new pfzOpButton(BRect(100,200,149,249),"/",pfz_DIV));
 AddChild(new pfzOpButton(BRect(50,200,99,249),"*",pfz_MULT));
 AddChild(new pfzValueButton(BRect(0,200,49,249),"0",0));
 txtControl=new BTextControl(BRect(7,15,192,0),buttonName,"Value:",NULL,0);
 txtControl->SetDivider(32);
 AddChild(txtControl);
 txtControl->TextView()->SetFlags(txtControl->TextView()->Flags()& ~B_NAVIGABLE);
 txtControl->TextView()->MakeEditable(false);
 Show();
}

pfzValueButton::pfzValueButton(BRect rect,char *caption,long value):BButton(rect,buttonName,caption,0){
 FValue=value;
// SetFlags(Flags()& ~B_NAVIGABLE);
}

status_t pfzValueButton::Invoke(BMessage *msg){
long a;
 if (FErase) {
  FErase=false;
  sscanf(txtControl->Text(),"%d",&OldValue);
  if (FValue){
   txtControl->SetText(Label());
  } else {
   txtControl->SetText("");
  }
 } else if ((a=strlen(txtControl->Text()))<9) if ((a>0)||(FValue>0)){
  strcpy(str,txtControl->Text());
  strcat(str,Label());
//  sscanf(A,"%d",&a);
//  sprintf(A,"%d",a);
  txtControl->SetText(str);
 }
 return BButton::Invoke(msg);
}

pfzCEButton::pfzCEButton(BRect rect,char *caption):BButton(rect,buttonName,caption,0){
// SetFlags(Flags()& ~B_NAVIGABLE);
}

status_t pfzCEButton::Invoke(BMessage *msg){
 txtControl->SetText("");
 OldValue=0;
 OldOP=pfz_EQUAL;
 LastEq=true;
 FErase=false;
 return BButton::Invoke(msg);
}

pfzOpButton::pfzOpButton(BRect rect,char *caption,pfz_OP value):BButton(rect,buttonName,caption,0){
 FOp=value;
// SetFlags(Flags()& ~B_NAVIGABLE);
}

status_t pfzOpButton::Invoke(BMessage *msg){
long V;
 if (!FErase){
  sscanf(txtControl->Text(),"%d",&NewValue);
 } else {
  sscanf(txtControl->Text(),"%d",&OldValue);
 }
 switch(OldOP){
  case pfz_PLUS:
   V=OldValue+NewValue;
   break;
  case pfz_MINUS:
   V=OldValue-NewValue;
   break;
  case pfz_MULT:
   V=OldValue*NewValue;
   break;
  case pfz_DIV:
   if (NewValue==0){
    beep();
    goto cont;
   } else {
    V=OldValue/NewValue;
   }
   break;
 }
 if ((!LastEq)||((OldOP!=pfz_EQUAL)&&(FOp==pfz_EQUAL))){
  sprintf(str,"%d",V);
  txtControl->SetText(str);
 }
 LastEq=(FOp==pfz_EQUAL);
 cont:
 if (!FErase){
  OldValue=NewValue;
  FErase=true;
 }
 if (FOp!=pfz_EQUAL) OldOP=FOp;
 return BButton::Invoke(msg);
}

bool pfzWindow::QuitRequested(){
 be_app->PostMessage(B_QUIT_REQUESTED);
 return(true);
}